#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=WinButtons.ico
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=WinButtons
#AutoIt3Wrapper_Res_Fileversion=2.6.2.2
#AutoIt3Wrapper_Res_LegalCopyright=(c) 2011 Ath
#AutoIt3Wrapper_Res_Language=1033
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <Constants.au3>
;#include <WinAPI.au3> ; Copied only _WinAPI_SetWindowPos function from it, not completely included because of the size it adds

$AppVersion = "2.6.2"
; WinButtons 2.6.2
; Revision history:
;------------------
; 2011-04-15, v2.6.2.2
; * Changed the Window Extended Style parameters to exclude transparancy and include double buffering when painting, to avoid craniosopical's transparancy issues
; 2011-04-14, v2.6.2.1
; * Minor fixes/typos corrected
; 2011-04-13, v2.6.2.0
; + Added button captions now also duplicated as tooltips, to improve readability of long captions, and reveal the 'hidden' captions of buttons showing an image or clipped text. (Thanks, cranioscopical, for the hint!)
; + Added althide setting and -ah/-ah- commandline parameters to set Alternate Hide using the rather slow WinSetState() AutoIt3 function, to possibly solve some repainting issues.
; 2011-04-12, v2.6.1.2
; ! Fixed to allow > 9 parameters for :var<VarName>?n: feature
; * Minor fixes and documentation updates
; 2011-04-12, v2.6.1.1
; * Changed -msg and -ask/-asc to also expand environment variables on their message and title.
; * Changed -msg to also support a title message, by using a vertical bar (|) in the 'message' text.
; 2011-04-11, v2.6.1.0
; + Added feature of allowing environment variables in a button's command<n> setting, and caption<n> setting, and the Window's caption setting, by using the %env.variable% syntax.
; ! Fixed a bug if there where no variables defined
; 2011-04-08, v2.6.0.1
; + Added parameters for variables. :var<VarName>=<par1>[=<par2>..]: defines the parameter(s), and :var<VarName>?<parnr>: fills in the value of a parameter on that variable. Max. 9 parameters possible for now. Nestable.
; + Added -msg command parameter to display the rest of the command as a messagebox (to be used for debugging purposes), -hide is implied
; + Added -ask"[title|]message" command parameter to ask Yes/No confirmation using message (optional: title, separated with |) in a messagebox and cancelling on No, -hide is implied
; + Added -asc"[title|]message" command parameter like -ask but with Ok/Cancel buttons, cancelling on Cancel, -hide is implied
; 2011-04-08, v2.5.1.0
; * Changed Now performs variable replacement on all non-boolean values from [Settings], [Buttons] etc. Only :var<VarName>: variables can be used!
; * Changed Now performs 'Execute()' on all numeric parameters read from the configuration files, just like already done on commandline parameters, so combined with variable replacement, calculations can be used for values
; 2011-04-07, v2.5.0.1
; * Changed Handling variable replacement, so the result of :var<VarName>: can contain parameters like :top: etc. for use in command<n> button parameter
; 2011-04-06, v2.5.0.0 (not released)
; + Added [Variables] support, so variables can be defined and used in commands, by using :var<VariableName>:, where VariableName (non-casesensitive) should be defined in [Variables] section. If not defined it's removed from the command.
; 2011-03-13, v2.0.1.0
; ! Removed check for Left and Top to be within the DektopWidth en DekstopHeight bounds, user has to check that himself...
; 2011-03-11, v2.0.0.2
; * Release version with context sensitive button sets (based/selected on application exe name)
; + Allow a list of exes in exename<n> parameter in [Groups] section.
; + Added top, left, buttonwidth, buttonheight, buttonmargin, buttonrows, vertical, backcolor and fontsize options to all [Buttons] settings, overriding any global setting, but not any commandline provided parameters
; + Added -a commandline option, to register and log (into WinButtons-active-exes.log) the actived/focussed executables while WinButtons was running. Saved when WinButtons is closed
; ! Fixed some bugs
; 2011-03-10, v1.6.0.0-beta
; + Added excludeexes option (global) defining a comma-separated list of to be excluded exe names where button context-switching should not occur
; ! Fixed some bugs
; 2011-03-08, v1.5.0.0-beta
; + Added detection of active application and load the appropriate set of buttons, switched to GUIOnEventMode mode from GUIGetMsg mode
; + Added [Groups] section and group<n>/exename<n> options to configuration to allow context dependent button sets
; + Added fontsize common option (global), and fontsize<n> per button option. The default font is fixed at 9 pt for now!
; + Added -fs <fontsize> commandline parameter for common fontsize setting
; ! Improved coloring of buttons
; 2011-03-08, v1.0.9.1
; ! Updated some of the offset data in the table
; + Added  a validity check ot buttonarrangement<n> setting
; 2011-03-07, v1.0.9
; + Implemented 6/-6 buttonarrangement
; * Improvements in the button-placement code
; 2011-03-05, v1.0.8
; * Try-out suggestion by nudone: Split/arrange/combine buttons
; + Added buttonarrangement<n> option, 0 = default, 1 = extend into next button, 2/-2 = split in half horizontally/vertically, 3/-3 = split in 3 horizontally/vertically, 4 = split in 4, 6/-6 split in 6 horizontally/vertically and depending on vertical 3x2/2x3, 9 split in 9
; + Added backcolor configuration option (global) to set the Window background color
; 2011-03-04, v1.0.0
; * Official first release version during the DonationCoder.com March2011 Fundraiser event.
; 2011-03-01, v0.9.7
; + Added a program icon, based on WinButtons own interface (3x3 buttons)
; + Added some resource information
; + Added -work"workdir" option for commands to set the application working directory
; 2011-02-27, v0.9.6
; + Added exitonesc configuration option (global, default enabled), to enable/disable closing the WinButtons window using the Esc key
; + Added -e and -e- option to set exitonesc from the commandline
; ! Rearranged the helpmessage slightly
; ! Minor changes
; 2011-02-26, v0.9.5
; + Added -sub option for commands to start a sub-session of WinButtons, -wait is also enabled
; + Added -quit option for commands to exit immediately (used to be -exit)
; * Changed -exit option for commands to exit after the command has returned
; + Added :debug: variable to pass the debug state to sub-processes (empty if 0 or -d if in debug mode)
; - Removed -hidex, -waitx, -sendx options for commands, -exit should be added
; * Switched hide/show window from WinSetState() to _WinAPI_SetWindowPos() for speed, copied local for exe size
; + Show application version in help-title
; * Changed debug, buttonwidth, buttonheight, buttonmargin, closebutton, border, taskbar and ontop to be read from the 'global' WinButtons.ini if not found in a local ini file, just like winsendkeys
; 2011-02-25, v0.9.4
; + Added -send and -sendx options for commands to activate WinSendKeys, configured in the Settings section, -sendx: exit afterward
; + Added winsendkeys option in [Settings], falling back to reading from WinButtons.ini if not found in current inifile. Specify full path/filename.
; ! Fixed a bug on command processing after first recognized option
; 2011-02-24, v0.9.3
; + Added -hnd <handle> option to add window-handle(s) to hide when -hide is used, repeat for more handles
; + Added :hndlist: variable to pass the -hnd list including the current window-handle through to secondary instances of WinButtons
; ! Minor changes
; 2011-02-22, v0.9.2
; + Added -cl and -cl- options to enable/disable close button on buttonwindow
; + Added per button buttonwidth<n> and buttonheight<n> config options
; + Added ontop config option, default enabled
; + Added -o and -o- options to enable/disable ontop mode
; ! Minor changes
; + Added some more logging messages
; 2011-02-21, v0.9.1
; + Added -b and -b- options to enable/disable border mode
; + Added -ta and -ta- options to enable/disable taskbar mode
; ! Some minor issues fixed
; 2011-02-20, v0.9
; + Added -d- option to disable debug mode
; + Added -x- option to disable exit mode
; + Added -v and -v- options to enable/disable vertical mode
; + Added -mv and -mv- options to enable/disable movable mode
; 2011-02-19, v0.8
; ! Fix minor bugs
; + Added -w <width> and -h <height> options for setting buttonwidth/buttonheight
; + Added -m <margin> option for setting buttonmargin (and bordermargin)
; + Added -r <rows> option to set no. of buttonrows
; + Added -? option to display helpmessage
; + Added position parameters for commands:
;   :top: :left: :right: :bottom: = Relative to Control so buttonwindows with same borders have overlapping/matching buttons
;   :btop: :bleft: :bright: :width: :height: = Button related
;   :wtop: :wleft: :wwidth: :wheight: :wright: :wbottom: = Window related
; ! Added parsing/calculation to -t -l -w -h options so :top:+10 or :left:+(:width:/2) etc. can be used in commands
; * Revamped command processing on button activation, added -hide, -hidex, -waitx options for commands
; + Added -c "caption text" option to set a caption text
; 2011-02-18, v0.5
; + Take inifile from command-line even without -f parameter
; + Additional debug-logging
; + Added color per button config option (background and text, not for icon/bitmap buttons!)
; + Added caption per button, separate from buttonname, in config
; + Added -t <top> and -l <left> options
; + Added -x parameter to make -runx default behavour
; 2011-02-17, v0.3
; + Fix up properties for border and close options
; + Added buttonrows config option
; + Added taskbar config option
; + Added movable config option
; + Added debug-logging at useful places
; 2011-02-15, v0.1
; + Initial version, to complete yet Unfinished CodingSnack: http://www.donationcoder.com/forum/index.php?topic=25167.0
; + Create buttons in a tightly fitting window displaying either text or a bitmap or icon, and execute some command if pressed
;   Can be used to start external tools like WinSendKeys for commanding some application or execute a task
; + Added -f <inifile> to load settings from that file
; + Added vertical config option
; + Added border config option

; Initialize parameters
; Command parameters
$dbg = 0 ; Debug mode
$dbgfile = "" ; Write logging to this file
$fname = "" ; File to read settings from
$initgrid = 0 ; Grid not yet initialized
Dim $offsetGrid[38][19]
; GUI parameters
$ButtonMargin = 2 ; Default margin
$ButtonCount = 0 ; Buttons found in config
$winClasses = 0
$winActivateClass = "" ;
$lastClass = ""
$GroupCount = 0 ; Groups found in config
Dim $HndList[1] = [0] ; List of handles to hide, item 0 is the count of handles listed
Dim $ExcludeExe[1] = [0] ; List of excludable exes. Is only read once from the configuration, item [0] is the count of filenames
Dim $proglist[1] = [0] ; List of detected programs, for debug logging only
Dim $varList[1] = [0] ; List of variables defined in [Variables] section of inifile, structure read using IniReadSection()
; Check-off parameters
$haveDbg = 0
$haveLeft = 0
$haveTop = 0
$haveWidth = 0
$haveHeight = 0
$haveMargin = 0
$haveRows = 0
$haveCaption = 0
$haveVertical = 0
$haveMovable = 0
$haveRunExit = 0
$haveBorder = 0
$haveTaskbar = 0
$haveClose = 0
$haveOntop = 0
$haveEsc = 0
$haveFont = 0
$haveAltHide = 0
$Left = -1 ; Center on screen
$Top = -1 ; Center on screen
$BHeight = 128 ; Default buttonheight
$BWidth = 128 ; Default buttonwidth
$vertical=0 ; Display buttons vertical or horizontal
$close = 0 ; Display Close button on border ($border=1 enforced)
$border = 0 ; Display border
$taskbar = 0 ; Show button on windows taskbar
$movable = 0 ; Window movable?
$BRows = 1 ; No. of rows of buttons to display
$help = 0 ; Display helpmessage if 1
$caption = "" ; Window caption
$ontop = 1 ; Window always on top
$runExit = 0 ; Exit after run if 1
$wskpath = "" ; WinSendKeys path
$exitonesc = 1 ; Esc pressed quits WinButtons
$backcolor = ""; Background color for the window
$fontSize = 0 ; Default no global fontsize set
$showProg = 0 ; Log all activated/focused exes while WinButtons was active
$altHide = 0 ; Alternative WindowHide method using the rather slow WinSetState()
; parse commandline parameters
$cmdl = ""
For $p = 1 To $CmdLine[0]
	$cmdl &= $CmdLine[$p] & " "
Next
$p = 1
$n = 1
While $n <= $CmdLine[0]
	If ($p = $n) And (StringLeft($CmdLine[$n], 1) = "-") Then
		If StringLower($CmdLine[$n]) = "-d" Then
			$dbg = 1
			$haveDbg = 1
			$p = $n + 1
			$dbgfile = StringReplace(@ScriptName, ".exe", ".log")
			If $dbgfile = @ScriptName Then
				$dbgfile = StringReplace(@ScriptName, ".au3", ".log")
				If $dbgfile = @ScriptName Then $dbgfile = @ScriptName & ".log" ; Extra safety-measure
			EndIf
			writeLogLine("Debug logging enabled")
			writeLogLine("Commandline: " & $cmdl)
		EndIf
		If StringLower($CmdLine[$n]) = "-d-" Then
			$dbg = 0
			$haveDbg = 1
			$p = $n + 1
		EndIf
		If (StringLower($CmdLine[$n]) = "-hnd") And ($n < $CmdLine[0]) Then
			$n = $n + 1
			$HndList[0] += 1
			ReDim $HndList[$HndList[0] + 1]
			$HndList[$HndList[0]] = HWnd($CmdLine[$n])
			$p = $n + 1
			If $dbg Then writeLogLine("Handle (-hide) added to list: " & $HndList[$HndList[0]])
		EndIf
		If (StringLower($CmdLine[$n]) = "-f") And ($n < $CmdLine[0]) Then
			$n = $n + 1
			$fname = $CmdLine[$n]
			$p = $n + 1
			If $dbg Then writeLogLine("Filemode (-f), reading from file: " & $fname)
		EndIf
		If (StringLower($CmdLine[$n]) = "-t") And ($n < $CmdLine[0]) Then
			$n = $n + 1
			$Top = Execute($CmdLine[$n])
			$haveTop = 1
			$p = $n + 1
			If $dbg Then writeLogLine("Top set to: " & $Top)
		EndIf
		If (StringLower($CmdLine[$n]) = "-l") And ($n < $CmdLine[0]) Then
			$n = $n + 1
			$Left = Execute($CmdLine[$n])
			$haveLeft = 1
			$p = $n + 1
			If $dbg Then writeLogLine("Left set to: " & $Left)
		EndIf
		If (StringLower($CmdLine[$n]) = "-w") And ($n < $CmdLine[0]) Then
			$n = $n + 1
			$BWidth = Execute($CmdLine[$n])
			$haveWidth = 1
			$p = $n + 1
			If $dbg Then writeLogLine("Buttonwidth set to: " & $BWidth)
		EndIf
		If (StringLower($CmdLine[$n]) = "-h") And ($n < $CmdLine[0]) Then
			$n = $n + 1
			$BHeight = Execute($CmdLine[$n])
			$haveHeight = 1
			$p = $n + 1
			If $dbg Then writeLogLine("Buttonheight set to: " & $BHeight)
		EndIf
		If (StringLower($CmdLine[$n]) = "-m") And ($n < $CmdLine[0]) Then
			$n = $n + 1
			$ButtonMargin = Execute($CmdLine[$n])
			$haveMargin = 1
			$p = $n + 1
			If $dbg Then writeLogLine("Buttonmargin set to: " & $ButtonMargin)
		EndIf
		If (StringLower($CmdLine[$n]) = "-r") And ($n < $CmdLine[0]) Then
			$n = $n + 1
			$BRows = Execute($CmdLine[$n])
			$haveRows = 1
			$p = $n + 1
			If $dbg Then writeLogLine("Buttonrows set to: " & $BRows)
		EndIf
		If (StringLower($CmdLine[$n]) = "-b") Then
			$p = $n + 1
			$border = 1
			$haveBorder = 1
			If $dbg Then writeLogLine("Border mode enabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-b-") Then
			$p = $n + 1
			$border = 0
			$haveBorder = 1
			If $dbg Then writeLogLine("Border mode disabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-ta") Then
			$p = $n + 1
			$taskbar = 1
			$haveTaskbar = 1
			If $dbg Then writeLogLine("Taskbar mode enabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-ta-") Then
			$p = $n + 1
			$taskbar = 0
			$haveTaskbar = 1
			If $dbg Then writeLogLine("Taskbar mode disabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-cl") Then
			$p = $n + 1
			$close = 1
			$haveClose = 1
			If $dbg Then writeLogLine("Close button enabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-cl-") Then
			$p = $n + 1
			$close = 0
			$haveClose = 1
			If $dbg Then writeLogLine("Close button disabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-x") Then
			$p = $n + 1
			$runExit = 1
			$haveRunExit = 1
			If $dbg Then writeLogLine("RunExit mode enabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-x-") Then
			$p = $n + 1
			$runExit = 0
			$haveRunExit = 1
			If $dbg Then writeLogLine("RunExit mode disabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-c") And ($n < $CmdLine[0]) Then
			$n = $n + 1
			$caption = $CmdLine[$n]
			$haveCaption = 1
			$p = $n + 1
			If $dbg Then writeLogLine("Caption set to: " & $caption)
		EndIf
		If (StringLower($CmdLine[$n]) = "-v") Then
			$p = $n + 1
			$vertical = 1
			$haveVertical = 1
			If $dbg Then writeLogLine("Vertical mode enabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-v-") Then
			$p = $n + 1
			$vertical = 0
			$haveVertical = 1
			If $dbg Then writeLogLine("Vertical mode disabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-mv") Then
			$p = $n + 1
			$movable = 1
			$haveMovable = 1
			If $dbg Then writeLogLine("Movable mode enabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-mv-") Then
			$p = $n + 1
			$movable = 0
			$haveMovable = 1
			If $dbg Then writeLogLine("Movable mode disabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-o") Then
			$p = $n + 1
			$ontop = 1
			$haveOntop = 1
			If $dbg Then writeLogLine("Ontop mode enabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-o-") Then
			$p = $n + 1
			$ontop = 0
			$haveOntop = 1
			If $dbg Then writeLogLine("Ontop mode disabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-e") Then
			$p = $n + 1
			$exitonesc = 1
			$haveEsc = 1
			If $dbg Then writeLogLine("ExitOnEsc mode enabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-e-") Then
			$p = $n + 1
			$exitonesc = 0
			$haveEsc = 1
			If $dbg Then writeLogLine("ExitOnEsc mode disabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-fo") And ($n < $CmdLine[0]) Then
			$n = $n + 1
			$fontSize = Execute($CmdLine[$n])
			$haveFont = 1
			$p = $n + 1
			If $dbg Then writeLogLine("Fontsize set to: " & $fontSize)
		EndIf
		If (StringLower($CmdLine[$n]) = "-a") Then
			$p = $n + 1
			$showProg = 1
			If $dbg Then writeLogLine("ActiveExe mode enabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-ah") Then
			$p = $n + 1
			$altHide = 1
			$haveAltHide = 1
			If $dbg Then writeLogLine("Alternate Hide mode enabled")
		EndIf
		If (StringLower($CmdLine[$n]) = "-ah-") Then
			$p = $n + 1
			$altHide = 0
			$haveAltHide = 1
			If $dbg Then writeLogLine("Alternate Hide mode disabled")
		EndIf
		If StringLower($CmdLine[$n]) = "-?" Then
			$p = $n + 1
			$help = 1
			If $dbg Then writeLogLine("Help enabled")
		EndIf
	EndIf
	$n = $n + 1
WEnd
; Default to use this file, named on the commandline, as configuration
If $fname = "" And $p <= $CmdLine[0] Then
	$fname = $CmdLine[$p]
	$p = $p + 1
	If $dbg Then writeLogLine("Filemode (cmdline), file: " & $fname)
EndIf
$mainLoop = 1
While $mainLoop
	$mainLoop = 0
	; Clear all button/group arrays for each separate session/window
	Dim $Buttons[1] ; Buttoncontrol handle
	Dim $Images[1] ; Image to display on the button
	Dim $Captions[1] ; Caption text
	Dim $Commands[1] ; Command to execute
	Dim $Colors[1] ; Background color
	Dim $TextColors[1] ; Text color
	Dim $BuWidths[1] ; Width of each button
	Dim $BuHeights[1] ; Height of each button
	Dim $BuArrange[1] ; Arrangement of each button
	Dim $BuFontsize[1] ; Fontsize of each button
	Dim $GroupNames[1] ; Name of the group [<group>-buttons] section
	Dim $GroupExes[1] ; Executable filenames to detect, no path!

	AutoItSetOption("WinTitleMatchMode", 4)
	AutoItSetOption("GUIResizeMode", 1)
	AutoItSetOption("GUIOnEventMode", 1)

	; Read all parameters
	loadSettings($winActivateClass)

	If $ButtonCount = 0 Or $help Then
		If $dbg And $help = 0 Then writeLogLine("No buttons found, File : " & $fname & ", Cmdline[0]: " & $CmdLine[0] & " $p: " & $p)
		showHelp()
	Else
		If $exitonesc = 0 Then AutoItSetOption("GUICloseOnESC",0)

		; Determine the number of 'button-areas', instead of buttons
		$arrangecnt = 0
		$arrangetyp = 0
		$bcc = 0
		; Determine the required no. of button-areas
		For $n = 0 to $ButtonCount - 1
			If $arrangetyp <> $BuArrange[$n] Then
				$arrangecnt = checkPreviousButton($arrangetyp, $BuArrange[$n], $vertical, $arrangecnt)
			EndIf
			$arrangetyp = $BuArrange[$n]
			If $arrangecnt = 0 Then
				$bcc += 1
			EndIf
			Switch $BuArrange[$n]
				Case 0 ; default
				Case 1 ;
					$bcc += 1
				Case 2,-2 ; split horizontically or vertically
					$arrangecnt += 1
					If $arrangecnt = 2 Then
						$arrangecnt = 0
					EndIf
				Case 3,-3 ; split horizontically or vertically in 3 parts
					$arrangecnt += 1
					If $arrangecnt = 3 Then
						$arrangecnt = 0
					EndIf
				Case 4 ; 2x2-split
					$arrangecnt += 1
					If $arrangecnt = 4 Then
						$arrangecnt = 0
					EndIf
				Case 6,-6 ; split horizontically or vertically in 2x3/3x2 parts
					$arrangecnt += 1
					If $arrangecnt = 6 Then
						$arrangecnt = 0
					EndIf
				Case 9 ; 3x3-split
					$arrangecnt += 1
					If $arrangecnt = 9 Then
						$arrangecnt = 0
					EndIf
			EndSwitch
		Next

		; Determine size of the window
		If $BRows <= 1 Or $bcc = 1 Then ; 1 button can only have 1 row
			$BCount = $bcc
			$BRows = 1
		Else
			$BCount = Ceiling($bcc / $BRows)
		EndIf
		If $vertical Then
			$Width = ($BRows * ($ButtonMargin + $BWidth)) + $ButtonMargin
			$Height = ($BCount * ($ButtonMargin + $BHeight)) + $ButtonMargin
		Else
			$Width = ($BCount * ($ButtonMargin + $BWidth)) + $ButtonMargin
			$Height = ($BRows * ($ButtonMargin + $BHeight)) + $ButtonMargin
		EndIf
		If Not ($Top = -1 And $Left = -1) Then
			If $Top = -1 Then $Top = (@DesktopHeight - $Height) / 2 ; Not precisely accurate centered... windowborder is not accounted for
			If $Left = -1 Then $Left = (@DesktopWidth - $Width) / 2
		EndIf
		If $dbg Then writeLogLine("Rows: " & $BRows & " Columns: " & $BCount & " Vertical: " & $vertical & " Width: " & $Width & " Height: " & $Height & " Top: " & $Top & " Left: " & $Left & " Margin: " & $ButtonMargin)
		; Border style
		$winstyle = BitOR($WS_VISIBLE, $WS_CLIPCHILDREN, $WS_POPUP)
		$winexstyle = $WS_EX_COMPOSITED ; BitOR($WS_EX_TRANSPARENT, $WS_EX_COMPOSITED)
		If $backcolor = "" Then
			$winexstyle = BitOR($winexstyle, $WS_EX_STATICEDGE) ; $WS_EX_TRANSPARENT,
		EndIf
		If $border Then
			If $caption <> "" Then
				$winstyle = BitOR($winstyle, $WS_CAPTION)
			EndIf
			If $close Then
				$winstyle = BitOR($winstyle, $WS_BORDER, $WS_DLGFRAME)
				; $winexstyle = BitOR($winexstyle)
			;Else
				; $winexstyle = BitOR($winexstyle)
			EndIf
			$winstyle = BitOR($winstyle, $WS_THICKFRAME)
		Else
			;$winstyle = BitOR($winstyle)
			If $backcolor = "" Then $winexstyle = BitOR($winexstyle, $WS_EX_DLGMODALFRAME)
		EndIf
		If $taskbar = 0 Then $winexstyle = BitOR($winexstyle, $WS_EX_TOOLWINDOW)
		If $movable Then $winexstyle = BitOR($winexstyle, $WS_EX_CONTROLPARENT)
		If $ontop Then $winexstyle = BitOR($winexstyle, $WS_EX_TOPMOST)
		If $dbg Then writeLogLine("Border: " & $border & " Close: " & $close & " Taskbar: " & $taskbar & " Movable: " & $movable & " Ontop: " & $ontop)

		AutoItSetOption("ExpandEnvStrings", 1) ; Allow for environment variables to be expanded
		$Form1 = GUICreate($caption, $Width, $Height, $Left, $Top, $winstyle , $winexstyle)
		AutoItSetOption("ExpandEnvStrings", 0) ; Restore setting
		GUISetOnEvent($GUI_EVENT_CLOSE, "CloseAction")

		If $backcolor <> "" Then
			GUISetBkColor($backcolor, $Form1)
		EndIf
		$BTop = $ButtonMargin
		$BLeft = $ButtonMargin
		$prBTop = 0
		$prBLeft = 0
		$arrangecnt = 0
		$arrangetyp = 0
		$minstyle = BitOR($WS_TABSTOP, $WS_CHILD) ; Minimum style
		$style = BitOR($minstyle, $WS_GROUP) ; Start a group
		$bc = 1
		For $n = 0 to $ButtonCount - 1
			$imageOk = 0
			If $Images[$n] <> "" Then
				If FileExists($Images[$n]) Then
					If $dbg Then writeLogLine("Set buttonimage: " & $Images[$n] & " on button: " & $Captions[$n])
					$ext = StringLower(StringMid($Images[$n], StringInStr($Images[$n], ".", 0, -1))) ; Rightmost period
					If $ext = ".ico" Then
						$style = BitOR($style, $BS_ICON)
						$imageOk = 1
					EndIf
					If $ext = ".bmp" Then
						$style = BitOR($style, $BS_BITMAP)
						$imageOk = 1
					EndIf
					If $dbg And $imageOk = 0 Then writeLogLine("Could not set buttonimage: " & $Images[$n] & " on button: " & $Captions[$n])
				EndIf
			EndIf
			If $imageOk = 0 And $Colors[$n] = "" And $TextColors[$n] = "" Then
				$style = BitOR($style, $BS_MULTILINE) ; Only if no color is to be set, and not icon or bitmap applied, then long captions can be wrapped...
			EndIf
			; Determine button position in the maximum buttonbox
			$bbl = $BLeft
			$bbt = $BTop
			$bbh = $BHeight
			$bbw = $BWidth
			If $arrangetyp <> $BuArrange[$n] Then
				$arrangecnt = checkPreviousButton($arrangetyp, $BuArrange[$n], $vertical, $arrangecnt)
			EndIf
			$arrangetyp = $BuArrange[$n]
			Switch $BuArrange[$n]
				Case 0 ; default
				Case 1 ; Double width/height depending on vertical
					If $vertical Then
						$bbh += $ButtonMargin + $bbh
						$BTop += $ButtonMargin + $BHeight
					Else
						$bbw += $ButtonMargin + $bbw
						$BLeft += $ButtonMargin + $BWidth
					EndIf
				Case 2 ; split horizontically
					$arrangecnt += 1
					$bbh = ($bbh - $ButtonMargin) / 2
					If $arrangecnt = 2 Then
						$BTop = $prBTop
						$BLeft = $prBLeft
						$bbl = $prBLeft
						$bbt = $prBTop + ($bbh + $ButtonMargin)
						$arrangecnt = 0
					EndIf
				Case -2 ; split vertically
					$arrangecnt += 1
					$bbw = ($bbw - $ButtonMargin) / 2
					If $arrangecnt = 2 Then
						$BTop = $prBTop
						$bbt = $prBTop
						$BLeft = $prBLeft
						$bbl = $prBLeft + $bbw + $ButtonMargin
						$arrangecnt = 0
					EndIf
				Case 3 ; split horizontically in 3
					$arrangecnt += 1
					$bbh = Round(($bbh - ($ButtonMargin * 2)) / 3)
					If $arrangecnt = 2 Or $arrangecnt = 3 Then
						$BTop = $prBTop
						$bbt = $prBTop
						$BLeft = $prBLeft
						$bbl = $prBLeft
					EndIf
					If $arrangecnt = 2 Then
						$bbt = $prBTop + $bbh + $ButtonMargin
					EndIf
					If $arrangecnt = 3 Then
						$bbt = $prBTop + ($bbh + $ButtonMargin) * 2
						$arrangecnt = 0
					EndIf
				Case -3 ; split vertically in 3
					$arrangecnt += 1
					$bbw = Round(($bbw - ($ButtonMargin * 2)) / 3)
					If $arrangecnt = 2 Or $arrangecnt = 3 Then
						$BTop = $prBTop
						$bbt = $prBTop
						$BLeft = $prBLeft
						$bbl = $prBLeft
					EndIf
					If $arrangecnt = 2 Then
						$bbl = $prBLeft + $bbw + $ButtonMargin
					EndIf
					If $arrangecnt = 3 Then
						$bbl = $prBLeft + ($bbw + $ButtonMargin) * 2
						$arrangecnt = 0
					EndIf
				Case 4 ; 2x2-split
					$arrangecnt += 1
					$bbh = ($bbh - $ButtonMargin) / 2
					$bbw = ($bbw - $ButtonMargin) / 2
					If $arrangecnt > 1 And $arrangecnt <= 4 Then
						$BTop = $prBTop
						$bbt = $prBTop
						$BLeft = $prBLeft
						$bbl = $prBLeft
						If $arrangecnt = 4 Then
							$arrangecnt = 0
						EndIf
					EndIf
					If $vertical Then
						If $arrangecnt = 2 Or $arrangecnt = 0 Then
							$bbt = $bbt + ($bbh + $ButtonMargin)
						EndIf
						If $arrangecnt = 3 Or $arrangecnt = 0 Then
							$bbl = $bbl + $bbw + $ButtonMargin
						EndIf
					Else
						If $arrangecnt = 2 Or $arrangecnt = 0 Then
							$bbl = $bbl + $bbw + $ButtonMargin
						EndIf
						If $arrangecnt = 3 Or $arrangecnt = 0 Then
							$bbt = $bbt + $bbh + $ButtonMargin
						EndIf
					EndIf
				Case 6 ; 2x3/3x2-split depending on vertical
					$arrangecnt += 1
					If $vertical Then
						$bbh = Round(($bbh - ($ButtonMargin * 2)) / 3)
						$bbw = ($bbw - $ButtonMargin) / 2
					Else
						$bbw = Round(($bbw - ($ButtonMargin * 2)) / 3)
						$bbh = ($bbh - $ButtonMargin) / 2
					EndIf
					If $arrangecnt > 1 And $arrangecnt <= 6 Then
						$BTop = $prBTop
						$bbt = $prBTop
						$BLeft = $prBLeft
						$bbl = $prBLeft
						If $arrangecnt = 6 Then
							$arrangecnt = 0
						EndIf
					EndIf
					If $vertical Then
						If $arrangecnt = 4 Or $arrangecnt = 5 Or $arrangecnt = 0 Then
							$bbl = $bbl + $bbw + $ButtonMargin
						EndIf
						If $arrangecnt = 2 Or $arrangecnt = 5 Then
							$bbt = $bbt + $bbh + $ButtonMargin
						EndIf
						If $arrangecnt = 3 Or $arrangecnt = 0 Then
							$bbt = $bbt + (($bbh + $ButtonMargin) * 2)
						EndIf
					Else
						If $arrangecnt = 4 Or $arrangecnt = 5 Or $arrangecnt = 0 Then
							$bbt = $bbt + $bbh + $ButtonMargin
						EndIf
						If $arrangecnt = 2 Or $arrangecnt = 5 Then
							$bbl = $bbl + $bbw + $ButtonMargin
						EndIf
						If $arrangecnt = 3 Or $arrangecnt = 0 Then
							$bbl = $bbl + (($bbw + $ButtonMargin) * 2)
						EndIf
					EndIf
				Case -6 ; 3x2/2x3-split depending on vertical
					$arrangecnt += 1
					If $vertical Then
						$bbw = Round(($bbw - ($ButtonMargin * 2)) / 3)
						$bbh = ($bbh - $ButtonMargin) / 2
					Else
						$bbh = Round(($bbh - ($ButtonMargin * 2)) / 3)
						$bbw = ($bbw - $ButtonMargin) / 2
					EndIf
					If $arrangecnt > 1 And $arrangecnt <= 6 Then
						$BTop = $prBTop
						$bbt = $prBTop
						$BLeft = $prBLeft
						$bbl = $prBLeft
						If $arrangecnt = 6 Then
							$arrangecnt = 0
						EndIf
					EndIf
					If $vertical Then
						If $arrangecnt = 4 Or $arrangecnt = 5 Or $arrangecnt = 0 Then
							$bbt = $bbt + $bbh + $ButtonMargin
						EndIf
						If $arrangecnt = 2 Or $arrangecnt = 5 Then
							$bbl = $bbl + $bbw + $ButtonMargin
						EndIf
						If $arrangecnt = 3 Or $arrangecnt = 0 Then
							$bbl = $bbl + (($bbw + $ButtonMargin) * 2)
						EndIf
					Else
						If $arrangecnt = 4 Or $arrangecnt = 5 Or $arrangecnt = 0 Then
							$bbl = $bbl + $bbw + $ButtonMargin
						EndIf
						If $arrangecnt = 2 Or $arrangecnt = 5 Then
							$bbt = $bbt + $bbh + $ButtonMargin
						EndIf
						If $arrangecnt = 3 Or $arrangecnt = 0 Then
							$bbt = $bbt + (($bbh + $ButtonMargin) * 2)
						EndIf
					EndIf
				Case 9 ; 3x3-split
					$arrangecnt += 1
					$bbh = Round(($bbh - ($ButtonMargin * 2)) / 3)
					$bbw = Round(($bbw - ($ButtonMargin * 2)) / 3)
					If $arrangecnt > 1 And $arrangecnt <= 9 Then
						$BTop = $prBTop
						$bbt = $prBTop
						$BLeft = $prBLeft
						$bbl = $prBLeft
						If $arrangecnt = 9 Then
							$arrangecnt = 0
						EndIf
					EndIf
					If $vertical Then
						If Ceiling($arrangecnt / 3) = 2 Then
							$bbl = $bbl + $bbw + $ButtonMargin
						EndIf
						If Ceiling($arrangecnt / 3) = 3 Or $arrangecnt = 0 Then
							$bbl = $bbl + (($bbw + $ButtonMargin) * 2)
						EndIf
						If $arrangecnt = 2 Or $arrangecnt = 5 Or $arrangecnt = 8 Then
							$bbt = $bbt + $bbh + $ButtonMargin
						EndIf
						If $arrangecnt = 3 Or $arrangecnt = 6 Or $arrangecnt = 0 Then
							$bbt = $bbt + (($bbh + $ButtonMargin) * 2)
						EndIf
					Else
						If Ceiling($arrangecnt / 3) = 2 Then
							$bbt = $bbt + $bbh + $ButtonMargin
						EndIf
						If Ceiling($arrangecnt / 3) = 3 Or $arrangecnt = 0 Then
							$bbt = $bbt + (($bbh + $ButtonMargin) * 2)
						EndIf
						If $arrangecnt = 2 Or $arrangecnt = 5 Or $arrangecnt = 8 Then
							$bbl = $bbl + $bbw + $ButtonMargin
						EndIf
						If $arrangecnt = 3 Or $arrangecnt = 6 Or $arrangecnt = 0 Then
							$bbl = $bbl + (($bbw + $ButtonMargin) * 2)
						EndIf
					EndIf
			EndSwitch
			; Center the button in the button-area
			If $BuWidths[$n] <> "" And $BuWidths[$n] > 0 And $BuWidths[$n] < $bbw Then
				$bbl += (($bbw - $BuWidths[$n]) / 2)
				$bbw = $BuWidths[$n]
			EndIf
			If $BuHeights[$n] <> "" And $BuHeights[$n] > 0 And $BuHeights[$n] < $bbh Then
				$bbt += (($bbh - $BuHeights[$n]) / 2)
				$bbh = $BuHeights[$n]
			EndIf
			; Create the button
			AutoItSetOption("ExpandEnvStrings", 1) ; Allow for environment variables to be expanded
			$Buttons[$n] = GUICtrlCreateButton($Captions[$n], $bbl, $bbt, $bbw, $bbh, $style)
			GUICtrlSetTip($Buttons[$n], StringReplace($Captions[$n], "&", "")) ; Set tooltip
			AutoItSetOption("ExpandEnvStrings", 0) ; Restore setting
			If $dbg Then writeLogLine("Created button: " & $Captions[$n] & " with handle: " & $Buttons[$n] & ", Button[" & $n & "]: l: " & $bbl & " t: " & $bbt & " h: " & $bbh & " w: " & $bbw & " Style: " & $style)
			If $imageOk Then ; No colors combined with bitmap or icon possible
				$ret = GUICtrlSetImage($Buttons[$n], $Images[$n])
				If $dbg Then writeLogLine("Buttonimage: " & $Images[$n] & " status (1 = OK): " & $ret)
			Else
				If $TextColors[$n] <> "" And $Captions[$n] <> "" Then
					GUICtrlSetColor($Buttons[$n], $TextColors[$n])
				EndIf
				If $Colors[$n] <> "" Then
					GUICtrlSetBkColor($Buttons[$n], $Colors[$n])
				EndIf
				If $BuFontsize[$n] <> "" And $BuFontsize[$n] > 0 Then
					GUICtrlSetFont($Buttons[$n], $BuFontsize[$n])
				Else
					If $fontSize <> "" And $fontSize > 0 Then
						GUICtrlSetFont($Buttons[$n], $fontSize)
					Else
						GUICtrlSetFont($Buttons[$n], getSystemFontSize())
					EndIf
				EndIf
				If $dbg Then writeLogLine("Buttoncolor: bkg: " & $Colors[$n] & " text: " & $TextColors[$n])
				If $Colors[$n] <> "" Or $TextColors[$n] <> "" Then
					ControlFocus("", "", $Buttons[$n]) ; Select button to repaint it with color(s) applied
				EndIf
			EndIf
			GUICtrlSetOnEvent($Buttons[$n], "ButtonActions") ; Redirect all buttons to the same eventfunction
			$bc += 1
			If $BuArrange[$n] <> 0 And $arrangecnt > 0 Then
				$prBTop = $BTop
				$prBLeft = $BLeft
			EndIf
			If $vertical Then
				If $BTop = (($BCount - 1) * ($BHeight + $ButtonMargin)) + $ButtonMargin Then
					$BLeft += $BWidth + $ButtonMargin ; Next column
					$BTop = $ButtonMargin
					$bc = 1
				Else
					$BTop += $BHeight + $ButtonMargin
				EndIf
			Else
				If $BLeft = (($BCount - 1) * ($BWidth + $ButtonMargin)) + $ButtonMargin Then
					$BTop += $BHeight + $ButtonMargin ; Next row
					$BLeft = $ButtonMargin
					$bc = 1
				Else
					$BLeft += $BWidth + $ButtonMargin
				EndIf
			EndIf
			If $BuArrange[$n] = "" Or $BuArrange[$n] = 0 or $arrangecnt = 0 Then
				$prBTop = $BTop
				$prBLeft = $BLeft
			EndIf
			$style = $minstyle
		Next
		GUISetState(@SW_SHOW)
		WinActivate($Form1) ; Activate the window
		If $ButtonCount > 0 Then ControlFocus("", "", $Buttons[0]) ; Focus on first button

		Local $thisClass = ""
		Local $pidList
		; Loop until finished
		$stayInLoop = 1
		While $stayInLoop
			Sleep(100) ; Check every 1/10th second
			$pid = WinGetProcess("[ACTIVE]","")
			If $pid <> -1 and $pid <> @AutoItPID Then ; Don't change buttonset when selecting the WinButtons window
				$w = 0
				$pidList = ProcessList()
				If $pidList[0][0] > 0 Then
					$thisClass = ""
					$n = 1
					While $n < $pidList[0][0]
						If $pidList[$n][1] = $pid Then
							$thisClass = $pidList[$n][0]
							$n = $pidList[0][0]
						EndIf
						$n += 1
					WEnd
				EndIf

				If ($dbg Or $showProg) And $thisClass <> "" And $thisClass <> $lastClass Then ; Register for logging
					$n = 1
					While $n <= $proglist[0]
						If StringCompare($proglist[$n], $thisClass) = 0 Then $n = $proglist[0] + 1
						$n += 1
					WEnd
					If $n = $proglist[0] + 1 Then ; Not found yet, add to list
						$proglist[0] += 1
						ReDim $proglist[$proglist[0] + 1]
						$proglist[$proglist[0]] = $thisClass
					EndIf
				EndIf
				If $thisClass <> "" And $ExcludeExe[0] > 0 And $thisClass <> $lastClass Then ; Check for excluded exes
					$n = 1
					While $n <= $ExcludeExe[0] And $thisClass <> ""
						If StringCompare($thisClass, $ExcludeExe[$n]) = 0 Then $thisClass = ""
						$n += 1
					WEnd
				EndIf
				If $thisClass <> "" And $thisClass <> $lastClass Then ; Switch needed?
					$oldActivClass = $winActivateClass
					$winActivateClass = "" ; Reset to standard buttonset
					$n = 0
					While $n < $GroupCount
						Local $groupShort = StringSplit($GroupExes[$n], ",") ; Check a list of exe's for 1 group
						For $p = 1 to $groupShort[0]
							If StringCompare($thisClass, $groupShort[$p]) = 0 Then
								$winActivateClass = $GroupNames[$n]
								$n = $GroupCount
							EndIf
						Next
						$n += 1
					WEnd
					If $winActivateClass <> $oldActivClass Then ; Reload window
						$mainLoop = 1
						$stayInLoop = 0
					EndIf
					$lastClass = $thisClass
				EndIf

			EndIf
		WEnd ; $stayInLoop
		GUIDelete($Form1) ; Clean up current window
	EndIf
WEnd ; $mainLoop
; ===>>> End Main

; Perform the defined action(s) for this button
Func ButtonActions()
	; Fire the pressed button
	Local $nMsg = @GUI_CtrlId
	For $n = 0 to $ButtonCount - 1
		If $Buttons[$n] = $nMsg And $Commands[$n] <> "" Then
			ControlFocus("","",$Buttons[$n]) ; Select button
			processCommand($Commands[$n], $Buttons[$n], $n)
		EndIf
	Next
EndFunc		;==>ButtonAction

; Things to do when shutting down
Func CloseAction()
	If ($dbg Or $showProg) And $proglist[0] > 0 Then
		If $dbgfile = "" Or $showProg Then
			$dbgfile = "WinButtons-active-exes.log" ; Debug without setting debug...
		EndIf
		For $n = 1 to $proglist[0]
			writeLogLine("activated exe: '" & $proglist[$n] & "'")
		Next
		For $n = 1 to $ExcludeExe[0]
			writeLogLine("excluded exe: '" & $ExcludeExe[$n] & "'")
		Next
	EndIf
	Exit
EndFunc		;==>CloseAction

;--------------------------------
; checkPreviousButton
; Determine the button-offset depending on the previous buttontype, it's position, and the vertical-mode
Func checkPreviousButton($atyp, $BuA, $vert, $acnt)
	Local $retval = $acnt
	Local $ox
	Local $oy
	If $initgrid = 0 Then ; Grid is fully defined because of possible expansion in options (7/-7, 8/-8)
		;          -6       -3 -2     0  1  2  3  4  5  6        9       x
		;  0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18 <- y  |
		Dim $offsetGrid[38][19] = _									   ; v
		[[ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 3] , _; -6, $vert
		 [ 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 3] , _; -6, Not $vert
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 1] , _; -3, $vert
		 [ 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _; -3, Not $vert
		 [ 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1] , _; -2, $vert
		 [ 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _; -2, Not $vert
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _; 0, $vert
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _; 0, Not $vert
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0] , _; 2, $vert
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 0, 0, 1] , _; 2, Not $vert
		 [ 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0] , _; 3, $vert
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 2, 0, 0, 1] , _; 3, Not $vert
		 [ 0, 0, 0, 2, 0, 0, 2, 3, 0, 0, 0, 2, 3, 0, 0, 3, 0, 0, 2] , _; 4, $vert
		 [ 0, 0, 0, 3, 0, 0, 3, 3, 0, 0, 0, 2, 2, 0, 0, 2, 0, 0, 2] , _; 4, Not $vert
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 3, 3, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 3] , _; 6, $vert
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 0, 0, 0, 0, 3] , _; 6, Not $vert
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] , _;
		 [ 0, 0, 0, 6, 0, 0, 3, 6, 0, 0, 0, 8, 7, 6, 0, 6, 0, 0, 0] , _; 9, $vert
		 [ 0, 0, 0, 6, 0, 0, 7, 8, 0, 0, 0, 6, 3, 6, 0, 6, 0, 0, 0] ]  ; 9, Not $vert
		;          -6       -3 -2     0  1  2  3  4  5  6        9       x
		$initgrid = 1
	EndIf

	$ox = 19 + (2 * $BuA) - $vert
	$oy = 9 + $atyp
	;--MsgBox(0,"Debug","ox : " & $ox & " oy : " & $oy & " atyp : " & $atyp & " BuA : " & $BuA)
	If ((Abs($atyp) = 2 Or Abs($atyp) = 3) And $acnt = 1) Or (Abs($atyp) = 4 And $acnt = 2) Or ((Abs($atyp) = 6 Or $atyp = 9) And $acnt < 4) Then
		$retval = $offsetGrid[$ox][$oy]
	Else
		; Some special cases, but not enough to enlarge (double) the grid
		If ((Abs($atyp) = 3 And $BuA = 9) And $acnt = 2) Then
			If ($vert And $atyp = -3) or (Not $vert And $atyp = 3) Then
				$retval = 6
			Else
				$retval = 8
			EndIf
		Else
			If (Abs($atyp) = 4 And $BuA = 9 And $acnt = 3) Then
				$retval = 8
			Else
				If (Abs($atyp) = 4 And $acnt = 1) Then
					If $BuA = -6 Then
						$retval = 0
					Else
						If $BuA = 9 Then
							$retval = 6
						Else
							$retval = Ceiling(Abs($BuA) / 2)
						EndIf
					EndIf
				Else
					If (Abs($atyp) = 6 And $BuA = 9 And $acnt < 6) Then
						$retval = $acnt + 3
					Else
						If (Abs($atyp) = 9 And $BuA = 3 And $acnt < 7) Then
							$retval = 2
						Else
							$retval = 0
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
	Return $retval
EndFunc		;==>checkPreviousButton

;--------------------------------
; processCommand
; parse command and execute as specified
;--------------------------------
Func processCommand($command, $button, $butNr)
	Local $cmd = $command
	Local $wait = 0
	Local $exit = 0
	Local $hide = 0
	Local $send = 0
	Local $sub = 0
	Local $msg = 0
	Local $ask = 0 ; Ask with Yes/No
	Local $asc = 0 ; Ask with OK/Cancel
	Local $save = ""
	Local $workdir = ""
	Local $message = "", $msgtitle = ""
	Local $ret = 0, $asr = 0, $asb = 0
	If $dbg Then writeLogLine("Process button[" & $butNr & "] " & $Captions[$butNr])
	If $dbg Then writeLogLine("Execute command (unprocessed): " & $cmd)
	While StringLeft($cmd,1) = "-" And $save <> $cmd
		$save = $cmd ; Avoid looping on unrecognised parameter
		Select
			Case StringLeft($cmd, 5) = "-quit" ; Quit this button-sharade immediately
				$exit = 1
				$cmd = "" ; Flush any further commands
			Case StringLeft($cmd, 5) = "-exit" ; Quit this button-sharade after the command
				$exit = 1
				$cmd = StringStripWS(StringMid($cmd, 6), 1)
			Case StringLeft($cmd, 5) = "-wait" ; wait for command to finish
				$wait = 1
				$cmd = StringStripWS(StringMid($cmd, 6), 1)
			Case StringLeft($cmd, 7) = "-nowait" ; do not wait for command to finish, optional for use with -sub
				$wait = 0
				$cmd = StringStripWS(StringMid($cmd, 8), 1)
			Case StringLeft($cmd, 5) = "-hide" ; Run (and wait) command but hide window(s)
				$hide = 1
				$wait = 1
				$cmd = StringStripWS(StringMid($cmd, 6), 1)
			Case StringLeft($cmd, 5) = "-send" ; Send keys to window specified (using WinSendKeys)
				$send = 1
				$cmd = StringStripWS(StringMid($cmd, 6), 1)
			Case StringLeft($cmd, 4) = "-sub" ; Sub-menu using WinButtons, -wait is implied
				$sub = 1
				$wait = 1
				$cmd = StringStripWS(StringMid($cmd, 5), 1)
			Case StringLeft($cmd, 4) = "-msg" ; Messagebox displaying the command, -hide is implied
				$msg = 1
				$hide = 1
				$cmd = StringStripWS(StringMid($cmd, 5), 1)
			Case StringLeft($cmd, 4) = "-ask" Or StringLeft($cmd, 4) = "-asc" ; Messagebox asking for confirmation (Yes/No or OK/Cancel) before the command is run, -hide is implied
				If StringLeft($cmd, 4) = "-ask" Then
					$asc = 1
				Else
					$ask = 1
				EndIf
				$hide = 1
				$cmd = StringStripWS(StringMid($cmd, 5), 1)
				Local $qu = 0
				If StringLeft($cmd, 1) = """" Then ; Starts with a " ?
					$qu = StringInStr($cmd, """", False, 2)
					If $qu > 0 Then
						$message = ReplaceParameters(StringMid(StringLeft($cmd, $qu), 2, $qu - 2), $button) ; Remove the quotes
						$cmd = StringStripWS(StringMid($cmd, $qu + 1), 1)
					EndIf
				Else ; Split on a space
					$qu = StringInStr($cmd, " ")
					If $qu > 0 Then
						$message = ReplaceParameters(StringLeft($cmd, $qu), $button)
						$cmd = StringStripWS(StringMid($cmd, $qu), 1)
					EndIf
				EndIf
			Case StringLeft($cmd, 5) = "-work" ; Parse for working directory
				$cmd = StringStripWS(StringMid($cmd, 6), 1)
				Local $qu = 0
				If StringLeft($cmd, 1) = """" Then ; Starts with a " ?
					$qu = StringInStr($cmd, """", False, 2)
					If $qu > 0 Then
						$workdir = StringMid(StringLeft($cmd, $qu), 2, $qu - 2) ; Remove the quotes
						$cmd = StringStripWS(StringMid($cmd, $qu + 1), 1)
					EndIf
				Else ; Split on a space
					$qu = StringInStr($cmd, " ")
					If $qu > 0 Then
						$workdir = StringLeft($cmd, $qu)
						$cmd = StringStripWS(StringMid($cmd, $qu), 1)
					EndIf
				EndIf
		EndSelect
		If $dbg Then writeLogLine("Execute command during processing: " & $cmd)
	WEnd

	$cmd = ReplaceParameters($cmd, $button) ; Variable expansion

	If $dbg Then writeLogLine("Execute options: hide: " & $hide & ", wait: " & $wait & ", send: " & $send & ", sub: " & $sub & ", exit: " & $exit & " Workdir: '" & $workdir & "'")
	If $cmd <> "" Then
		If $hide Then
			If $dbg Then writeLogLine("Hiding " & ($HndList[0] + 1) & " windows")
			WindowHide($Form1)
			If $HndList[0] > 0 Then ; Hide the entire list
				For $p = $HndList[0] To 1 Step -1
					WindowHide($HndList[$p])
				Next
			EndIf
		EndIf
		If $send Then
			If $wskpath <> "" Then
				$cmd = $wskpath & " " & $cmd
			EndIf
		EndIf
		If $sub Then
			$cmd = @ScriptName & " " & $cmd
		EndIf
		If $dbg Then writeLogLine("Execute command: " & $cmd)
		If $msg Then
			$msgtitle = "WinButtons"
			If StringInStr($cmd, "|") > 0 Then ; Title is left part of the message, separated by | (vertical bar)
				$msgtitle = StringLeft($cmd, StringInStr($cmd, "|") - 1)
				$cmd = StringMid($cmd, StringLen($msgtitle) + 2)
			EndIf
			AutoItSetOption("ExpandEnvStrings", 1) ; Allow for environment variables to be expanded
			MsgBox(0,$msgtitle, $cmd)
			AutoItSetOption("ExpandEnvStrings", 0) ; Restore setting to default
		Else
			If $ask Or $asc Then
				$msgtitle = "WinButtons"
				If StringInStr($message, "|") > 0 Then ; Title is left part of the message, separated by | (vertical bar)
					$msgtitle = StringLeft($message, StringInStr($message, "|") - 1)
					$message = StringMid($message, StringLen($msgtitle) + 2)
				EndIf
				$asb = 1 + (3 * $ask) + 32 ; Ask Buttonset: OK/Cancel (1) or Yes/No (4) with Questionmark icon (32)
				If StringLeft($message, 1) = "*" Then
					$asb += 256 ; Second button default
					$message = StringMid($message, 2)
				EndIf
				AutoItSetOption("ExpandEnvStrings", 1) ; Allow for environment variables to be expanded
				$asr = MsgBox($asb, $msgtitle, $message)
				AutoItSetOption("ExpandEnvStrings", 0) ; Restore setting to default
				If $asr = 2 Or $asr = 7 Then ; Cancel or No pressed: Don't execute
					$cmd = ""
				EndIf
			EndIf
			If $cmd <> "" Then
				AutoItSetOption("ExpandEnvStrings", 1) ; Allow for environment variables to be expanded
				If $wait Then
					$ret = RunWait($cmd, $workdir) ; Execute and wait for the command to finish
				Else
					$ret = Run($cmd, $workdir) ; Simply execute the command
				EndIf
				AutoItSetOption("ExpandEnvStrings", 0) ; Restore setting to default
			EndIf
		EndIf
		If $dbg Then writeLogLine("Execute command returned code: " & $ret)
		If $hide Then
			If $dbg Then writeLogLine("Unhiding " & ($HndList[0] + 1) & " windows")
			If $HndList[0] > 0 Then ; UnHide the entire list
				For $p = 1 To $HndList[0]
					WindowShow($HndList[$p])
				Next
			EndIf
			WindowShow($Form1)
		EndIf
		If $wait Then WinActivate($Form1)
		;If $sub Then
		;	$mainLoop = 1
		;	$stayInLoop = 0
		;EndIf
	EndIf
	If $runExit Or $exit Then Exit ; Quit if demanded
EndFunc    ;==>processCommand

;--------------------------------
; ReplaceParameters
; replace all positioning values in a string
;--------------------------------
Func ReplaceParameters($command, $button)
	Local $pcount = 18
	Local $i
	Local $para[$pcount] = [":var",":top:",":left:",":right:",":bottom:",":btop:",":bleft:",":bright:",":wtop:",":wleft:",":wwidth:",":wheight:",":wright:",":wbottom:",":width:",":height:",":hndlist:",":debug:"]
	Local $cpos = ControlGetPos("", "", $button)
	; MsgBox(0, "Button" & $n, "Position: x: " & $cpos[0] & " y: " & $cpos[1] & " w: " & $cpos[2] & " h: " & $cpos[3])
	Local $mpos = WinGetPos("", "")
	Local $msiz = WinGetClientSize("", "") ; [0] = width [1] = height
	; MsgBox(0, "Form1", "Position: x: " & $mpos[0] & " y: " & $mpos[1] & " w: " & $mpos[2] & " h: " & $mpos[3] & " cw: " & $msiz[0] & " ch: " & $msiz[1] & " b: " & (($mpos[2] - $msiz[0]) / 2))
	Local $return = $command
	Local $repl = ""
	Local $vsrc = ""
	For $i = 0 to $pcount - 1
		If StringInStr($return, $para[$i], 1) > 0 Then
			$repl = ""
			$vsrc = $para[$i]
			Switch Int($i)
				Case 0 ; :var<varname>: support
					$return = ReplaceVariables($return, $para[$i])
					$vsrc = ""
				Case 1
					$repl = $mpos[1] + $cpos[1] - $ButtonMargin ; top : top pixel of the control, ignores bordersizes so buttons align nicely
				Case 2
					$repl = $mpos[0] + $cpos[0] - $ButtonMargin ; left : left pixel of the control, ignores bordersizes so buttons align nicely
				Case 3
					$repl = $mpos[0] + $cpos[0] + $cpos[2] - $ButtonMargin ; right : right pixel of the control
				Case 4
					$repl = $mpos[1] + $cpos[3] ; bottom : top + height
				Case 5
					$repl = $mpos[1] + ($mpos[3] - $msiz[1]) - (($mpos[2] - $msiz[0]) / 2) + $cpos[1] ; btop : button top
				Case 6
					$repl = $mpos[0] + ($mpos[2] - $msiz[0]) / 2 + $cpos[0] ; bleft : button left
				Case 7
					$repl = $mpos[0] + ($mpos[2] - $msiz[0]) / 2 + $cpos[0] + $cpos[2] ; bright : button right
				Case 8
					$repl = $mpos[1] ; wtop : window top
				Case 9
					$repl = $mpos[0] ; wleft : window left
				Case 10
					$repl = $mpos[2] ; wwidth : window width
				Case 11
					$repl = $mpos[3] ; wheight : window height
				Case 12
					$repl = $mpos[0] + $mpos[2] ; wright : window right
				Case 13
					$repl = $mpos[1] + $mpos[3] ; wbottom : window bottom
				Case 14
					$repl = $cpos[2] ; width : button width
				Case 15
					$repl = $cpos[3] ; height : button height
				Case 16
					For $p = 1 to $HndList[0]
						$repl &= "-hnd " & $HndList[$p] & " "
					Next
					$repl &= "-hnd " & $Form1 ; hndlist : list of window-handles to hide when -hide is used
				Case 17
					If $dbg Then $repl = "-d" ; Pass through the debug state
			EndSwitch
			If $vsrc <> "" Then
				$return = StringReplace($return, $vsrc, $repl)
			EndIf
		EndIf
	Next
	Return $return
EndFunc    ;==>ReplaceParameters

;------------------------------
; ReplaceVariables
; Replace :var<VarName>: with value stored in [Variables] section of the current configuration
; Value from VarName= is used, :var prefix is required to be lowercase
Func ReplaceVariables($in, $prefix = ":var", $postfix = ":")
	Local $repl = "", $ch = 0
	Local $vsrc = "", $bp, $sp, $cp, $vvar, $ip
	Local $pv, $vpv, $xvvar
	Dim $par[1]
	While StringInStr($in, $prefix, 1) > 0
		$vsrc = $prefix
		$repl = ""
		$bp = StringInStr($in, $vsrc, 1)
		$sp = StringInStr($in, $postfix, 1, 1, $bp + 1)
		While StringMid($in, $sp, StringLen($prefix)) = $prefix
			$bp = $sp
			$sp = StringInStr($in, $postfix, 1, 1, $bp + 1)
		WEnd
		$vsrc = StringMid($in, $bp, ($sp - $bp) + StringLen($postfix))
		$vvar = StringMid($vsrc, 1 + StringLen($prefix), (StringLen($vsrc) - StringLen($prefix)) - StringLen($postfix))
		If StringInStr($vvar, "=") > 0 Then
			$par = StringSplit($vvar, "=")
			$vvar = $par[1]
		Else
			ReDim $par[1]
			$par[0] = 0
		EndIf
		If UBound($varList, 0) > 1 And $vvar <> "" Then
			For $ip = 1 To $varList[0][0] ; Find in the [Variables] list
				If StringCompare($varList[$ip][0], $vvar) = 0 Then
					$repl = $varList[$ip][1]
				EndIf
			Next
		EndIf
		If StringInStr($repl, "?") > 0 Then ; Replace all var parameters
			While StringInStr($repl, "?") > 0
				$pv = StringInStr($repl, "?")
				$pv += 1
				$xvvar = StringMid($repl, $pv, 1)
				$pv += 1
				While StringMid($repl, $pv, 1) >= "0" And StringMid($repl, $pv, 1) <= "9" ; parse for numeric parameter id
					$xvvar &= StringMid($repl, $pv, 1)
					$pv += 1
				WEnd
				$vpv = ""
				If Int($xvvar) > 0 And $xvvar <= $par[0] - 1 Then
					$vpv = $par[$xvvar + 1]
				EndIf
				If Int($xvvar) > 0 Then
					If $dbg Then writeLogLine("Replaced parameter '?" & $xvvar & "' with '" & $vpv & "'")
					$repl = StringReplace($repl, "?" & $xvvar, $vpv, 1) ; By doing 1 replacement at a time, allows for > 9 parameters
					If @extended > 0 Then $ch = 1
				EndIf
			WEnd
		EndIf
		If $dbg Then writeLogLine("Replaced " & $vsrc & " (" & $vvar & ")" & " with '" & $repl & "'")
		$in = StringReplace($in, $vsrc, $repl)
		If @extended > 0 Then $ch = 1
	WEnd
	;If $ch Then MsgBox(0, "Debug", "Return: " & $in)
	Return $in
EndFunc		;==>ReplaceVariables

;---------------------------------
; loadSettings
; Read parameters from an ini file
;---------------------------------
Func loadSettings($group = "")
	Local $ini = StringReplace(@ScriptName, ".exe", ".ini")
	Local $gini = $ini ; Global Inifile, always WinButtons.ini as a fallback/global
	Local $sectName = "Buttons" ; Base/default section
	If $fname <> "" Then $ini = $fname ; Override with commandline parameter -f
	If $ini = @ScriptName Then
		$ini = StringReplace(@ScriptName, ".au3", ".ini")
		If $ini = @ScriptName Then $ini = "" ; Safety first
	EndIf
	If $gini = @ScriptName Then
		$gini = StringReplace(@ScriptName, ".au3", ".ini")
		If $gini = @ScriptName Then $gini = "" ; Safety first
	EndIf
	If $ini <> "" And FileExists($ini) Then
		; Debugmode
		If $haveDbg = 0 Then ; If debug not yet set from commandline, read it from the ini file
			$dbg = IniReadOrGlobal($ini,"Settings","debug",$dbg,$gini)
			If $dbg = 0 Then $dbg = 0 ; make numeric zero
			If $dbg > 0 Then ; Set up the logfile
				$dbg = 1
				$dbgfile = StringReplace(@ScriptName, ".exe", ".log")
				If $dbgfile = @ScriptName Then
					$dbgfile = StringReplace(@ScriptName, ".au3", ".log")
					If $dbgfile = @ScriptName Then $dbgfile = @ScriptName & ".log" ; Extra safety-measure
				EndIf
				writeLogLine("Debug logging enabled")
			EndIf
		EndIf

		; Read any Variables from that section, and read it here so they can be used in configuration parameters
		$varList = IniReadSection($ini, "Variables")
		If UBound($varList, 0) > 1 And @error = 0 Then
			If $dbg Then writeLogLine("Found " & $varList[0][0] & " variables in configuration: " & $ini)
		EndIf

		; Global button parameters
		; Position and size
		If $haveLeft = 0 Then $Left = Execute(ReplaceVariables(IniRead($ini, "Settings", "left", -1)))
		If $haveTop = 0 Then $Top = Execute(ReplaceVariables(IniRead($ini, "Settings", "top", -1)))
		If $haveWidth = 0 Then $BWidth =  Execute(ReplaceVariables(IniReadOrGlobal($ini, "Settings", "buttonwidth", 128, $gini)))
		If $haveHeight = 0 Then $BHeight =  Execute(ReplaceVariables(IniReadOrGlobal($ini, "Settings", "buttonheight", 128, $gini)))
		If $haveMargin = 0 Then $ButtonMargin = Execute(ReplaceVariables(IniReadOrGlobal($ini, "Settings", "buttonmargin", 2, $gini)))
		If $haveClose = 0 Then $close = IniReadOrGlobal($ini, "Settings", "closebutton", $close, $gini)
		If $close = 0 Then $close = 0 ; make numeric zero
		If $haveBorder = 0 Then $border = IniReadOrGlobal($ini, "Settings", "border", $border, $gini)
		If $border = 0 Then $border = 0 ; make numeric zero
		;If $close Then $border = 1 ; Force border on when close is enabled
		If $haveTaskbar = 0 Then $taskbar = IniReadOrGlobal($ini, "Settings", "taskbar", $taskbar, $gini)
		If $taskbar = 0 Then $taskbar = 0 ; make numeric zero
		If $haveVertical = 0 Then $vertical = IniRead($ini, "Settings", "vertical", 0)
		If $vertical = 0 Then $vertical = 0 ; make numeric zero
		If $haveMovable = 0 Then $movable = IniRead($ini, "Settings", "movable", $movable)
		If $movable = 0 Then $movable = 0 ; make numeric zero
		If $haveRows = 0 Then $BRows = Execute(ReplaceVariables(IniRead($ini, "Settings", "buttonrows", 1)))
		If $BRows = 0 Then $BRows = 0 ; make numeric zero
		If $haveRunExit = 0 Then $runExit = IniRead($ini, "Settings", "runexit", $runExit)
		If $runExit = 0 Then $runExit = 0 ; make numeric zero
		If $haveOntop = 0 Then $ontop = IniReadOrGlobal($ini, "Settings", "ontop", $ontop, $gini)
		If $ontop = 0 Then $ontop = 0 ; make numeric zero
		If $haveCaption = 0 Then $caption = ReplaceVariables(IniRead($ini, "Settings", "caption", $caption))
		If $haveFont = 0 Then $fontSize = Execute(ReplaceVariables(IniReadOrGlobal($ini, "Settings", "fontsize", getSystemFontSize(), $gini)))
		If $haveEsc = 0 Then $exitonesc = IniReadOrGlobal($ini, "Settings", "exitonesc", $exitonesc, $gini)
		If $exitonesc = 0 Then $exitonesc = 0 ; make numeric zero
		If $haveAltHide = 0 Then $altHide = IniReadOrGlobal($ini, "Settings", "althide", $altHide, $gini)
		If $altHide = 0 Then $altHide = 0 ; make numeric zero
		$backcolor = ReplaceVariables(IniReadOrGlobal($ini, "Settings", "backcolor", $backcolor, $gini))
		$wskpath =  ReplaceVariables(IniReadOrGlobal($ini, "Settings", "winsendkeys", $wskpath, $gini))
		If $ExcludeExe[0] = 0 Then
			Local $exes = ReplaceVariables(IniReadOrGlobal($ini, "Settings", "excludeexes", "", $gini))
			If $exes <> "" Then
				$ExcludeExe = StringSplit($exes, ",")
			EndIf
			If $ExcludeExe[0] = 0 Then $ExcludeExe[0] = -1 ; Mark as checked
		EndIf

		; Groups
		$GroupCount = 0 ; Re-read, so reset.
		Local $gr = 1
		While IniRead($ini, "Groups", "group" & $gr, "") <> ""
			ReDim $GroupNames[$gr]
			ReDim $GroupExes[$gr]
			$GroupNames[$gr - 1] = IniRead($ini, "Groups", "group" & $gr, "")
			$GroupExes[$gr - 1] = IniRead($ini, "Groups", "exename" & $gr, "")
			If $group <> "" And StringCompare($group, $GroupNames[$gr - 1]) = 0 Then
				$sec = IniReadSection($ini, $group & "-" & $sectName)
				If @error = 0 Then ; Section must exist!
					$sectName = $group & "-" & $sectName
				EndIf
			EndIf
			$GroupCount = $gr
			$gr += 1
		WEnd
		If $dbg And $GroupCount > 0 Then writeLogLine("Found " & $GroupCount & " groups in configuration: " & $ini)

		; Buttons
		; Read group specific settings: top, left, buttonwidth, buttonheight, buttonmargin, vertical, buttonrows, window background color, fontsize
		Local $bcb
		If $haveLeft = 0 Then
			$bcb = ReplaceVariables(IniRead($ini, $sectName, "left", "*"))
			If $bcb <> "*" Then
				$Left = Execute($bcb)
			EndIf
		EndIf
		If $haveTop = 0 Then
			$bcb =  ReplaceVariables(IniRead($ini, $sectName, "top", "*"))
			If $bcb <> "*" Then
				$Top = Execute($bcb)
			EndIf
		EndIf
		If $haveWidth = 0 Then
			$bcb =  ReplaceVariables(IniRead($ini, $sectName, "buttonwidth", "*"))
			If $bcb <> "*" Then
				$BWidth = Execute($bcb)
			EndIf
		EndIf
		If $haveHeight = 0 Then
			$bcb =  ReplaceVariables(IniRead($ini, $sectName, "buttonheight", "*"))
			If $bcb <> "*" Then
				$BHeight = Execute($bcb)
			EndIf
		EndIf
		If $haveMargin = 0 Then
			$bcb = ReplaceVariables(IniRead($ini, $sectName, "buttonmargin", "*"))
			If $bcb <> "*" Then
				$ButtonMargin = Execute($bcb)
			EndIf
		EndIf
		If $haveVertical = 0 Then
			$bcb = ReplaceVariables(IniRead($ini, $sectName, "vertical", "*"))
			If $bcb <> "*" Then
				$vertical = $bcb
			EndIf
		EndIf
		If $haveRows = 0 Then
			$bcb = ReplaceVariables(IniRead($ini, $sectName, "buttonrows", "*"))
			If $bcb <> "*" Then
				$BRows = Execute($bcb)
			EndIf
		EndIf
		If $haveFont = 0 Then ; when not commandline overridden
			$bcb = ReplaceVariables(IniRead($ini, $sectName, "fontsize", "*"))
			If $bcb <> "*" Then
				$fontSize = Execute($bcb)
			EndIf
		EndIf
		$bcb = ReplaceVariables(IniRead($ini, $sectName, "backcolor", "*"))
		If $bcb <> "*" Then
			$backcolor = $bcb
		EndIf
		Local $mBWidth = $BWidth
		Local $mBHeight = $BHeight
		Local $ic = 1
		While IniRead($ini,$sectName, "button" & $ic, "") <> "" ; Buttondata
			ReDim $Buttons[$ic] ; used later for handle
			ReDim $Images[$ic]
			ReDim $Captions[$ic]
			ReDim $Commands[$ic]
			ReDim $Colors[$ic]
			ReDim $TextColors[$ic]
			ReDim $BuWidths[$ic]
			ReDim $BuHeights[$ic]
			ReDim $BuArrange[$ic]
			ReDim $BuFontsize[$ic]
			$Captions[$ic - 1] = ReplaceVariables(IniRead($ini, $sectName, "button" & $ic, ""))
			If IniRead($ini,$sectName,"caption" & $ic,"&") <> "&" Then ; Optionally override caption so it can be made empty
				$Captions[$ic - 1] = ReplaceVariables(IniRead($ini, $sectName, "caption" & $ic, ""))
			EndIf
			$Images[$ic - 1] = ReplaceVariables(IniRead($ini, $sectName, "image" & $ic, ""))
			$Commands[$ic - 1] = IniRead($ini, $sectName, "command" & $ic, "")
			$Colors[$ic - 1] = ReplaceVariables(IniRead($ini, $sectName, "color" & $ic, ""))
			$TextColors[$ic - 1] = ReplaceVariables(IniRead($ini, $sectName, "textcolor" & $ic, ""))
			$BuWidths[$ic - 1] = Int(Execute(ReplaceVariables(IniRead($ini, $sectName, "buttonwidth" & $ic, ""))))
			If $BuWidths[$ic - 1] <> "" And $BuWidths[$ic - 1] > 0 Then
				If Int($BuWidths[$ic - 1]) > $mBWidth Then
					$mBWidth = $BuWidths[$ic - 1]
				EndIf
			;Else ; Disabled for now
				;$BuWidths[$ic - 1] = $BWidth ; Use default width
			EndIf
			$BuHeights[$ic - 1] = Int(Execute(ReplaceVariables(IniRead($ini, $sectName, "buttonheight" & $ic, ""))))
			If $BuHeights[$ic - 1] <> "" And $BuHeights[$ic - 1] > 0 Then
				If Int($BuHeights[$ic - 1]) > $mBHeight Then
					$mBHeight = $BuHeights[$ic - 1]
				EndIf
			;Else ; Disabled for now
				;$BuHeights[$ic - 1] = $BHeight ; Use default height
			EndIf
			$BuArrange[$ic - 1] = Int(ReplaceVariables(IniRead($ini, $sectName, "buttonarrangement" & $ic, "")))
			; Validity check
			If Not ($BuArrange[$ic - 1] = 1 Or Abs($BuArrange[$ic - 1]) = 2 Or Abs($BuArrange[$ic - 1]) = 3 Or $BuArrange[$ic - 1] = 4 Or Abs($BuArrange[$ic - 1]) = 6 Or $BuArrange[$ic - 1] = 9) Then
				$BuArrange[$ic - 1] = 0
			EndIf
			;If $BuArrange[$ic - 1] = 1 Then ; Special case for arrangement type 1... if the default height and width are enforced
			;	If $vertical Then
			;		$BuHeights[$ic - 1] += $BHeight
			;	Else
			;		$BuWidths[$ic - 1] += $BWidth
			;	EndIf
			;EndIf
			$BuFontsize[$ic - 1] = Execute(ReplaceVariables(IniRead($ini, $sectName, "fontsize" & $ic, ""))) ; :var?
			$ButtonCount = $ic
			$ic += 1
		WEnd
		$BWidth = $mBWidth ; Create form using biggest buttonsizes
		$BHeight = $mBHeight
		If $dbg Then writeLogLine("Found " & $ButtonCount & " buttons in configuration: " & $ini)
	EndIf
EndFunc   ;==>loadSettings

;---------------------------------
; IniReadOrGlobal
; Like IniRead(), but with a fall-back on missing value to read from a Global inifile
;
Func IniReadOrGlobal($ifile,$section,$variable,$defaultvalue,$gfile)
	Local $ret
	$ret = IniRead($ifile, $section, $variable, $defaultvalue)
	If $ret = $defaultvalue And $gfile <> "" And $ifile <> $gfile And IniRead($ifile, $section, $variable, "**") = "**" And FileExists($gfile) Then
		$ret = IniRead($gfile, $section, $variable, $defaultvalue)
	EndIf
	Return $ret
EndFunc	;==>IniReadOrGlobal

;--------------------------
; writeLogLine($message)
; Write $message to the logfile, prepended with date/time
;--------------------------
Func writeLogLine($message)
	; Write a line to the logfile, with a prefix of "yyyy-MM-dd hh:mm:ss.msec, ", as the generic _FileWriteLog function gave errors
	Local $openLogFile = FileOpen($dbgfile, 1)
	If $openLogFile > -1 Then
		FileWriteLine($openLogFile, @YEAR & "-" & @MON & "-" & @MDAY & " " & @HOUR & ":" & @MIN & ":" & @SEC & "." & StringFormat("%03d", @MSEC) & ", " & $message)
		FileClose($openLogFile)
	EndIf
EndFunc   ;==>writeLogLine

;--------------------------
; showHelp()
; Display a messagebox with some help text
;--------------------------
Func ShowHelp()
	MsgBox(0, "WinButtons " & $AppVersion & ": Display a set of (big) buttons", _
			"WinButtons [-d|-d-] [-t top] [-l left] [-w width] [-h height] [-m margin] [-r rows]" & @CRLF _
			 & @TAB & "[-v|-v-] [-b|-b-] [-ta|-ta-] [-x|-x-] [-mv|-mv-] [-cl|-cl-] [-o|-o-] [-e|-e-]" & @CRLF _
			 & @TAB & "[-fs fontsize] [-a] [-ah|-ah-] [-hnd handle] [-c caption] [-f] [buttonfile]" & @CRLF _
			 & "Display a window with (big) buttons, useful for touch-screens/menu's." & @CRLF _
			 & "Options:" & @CRLF _
			 & "-d or -d- = Enable/Disable Debug mode, write log info to WinButtons.log" & @CRLF _
			 & "-t top = top coordinate of window (default: -1 = center window)" & @CRLF _
			 & "-l left = left coordinate of window (default: -1 = center window)" & @CRLF _
			 & "-w width = buttonwidth (default: 128)" & @CRLF _
			 & "-h height = buttonheight (default: 128)" & @CRLF _
			 & "-m margin = margin between buttons and border (default: 2)" & @CRLF _
			 & "-r rows = rows of buttons to display (default: 1)" & @CRLF _
			 & "-v or -v- = Vertical mode enabled or disabled" & @CRLF _
			 & "-b or -b- = Border mode enabled or disabled" & @CRLF _
			 & "-ta or -ta- = Taskbar mode enabled or disabled" & @CRLF _
			 & "-x or -x- = Exit after running command enabled or disabled" & @CRLF _
			 & "-mv or -mv- = Movable mode enabled or disabled" & @CRLF _
			 & "-cl or -cl- = Close button enabled or disabled" & @CRLF _
			 & "-o or -o- = Ontop mode enabled or disabled, (default: enabled)" & @CRLF _
			 & "-e or -e- = ExitOnEsc mode enabled or disabled, (default: enabled)" & @CRLF _
			 & "-hnd handle = add handle to hide-list, see readme for details" & @CRLF _
			 & "-c caption = title for the window. border required" & @CRLF _
			 & "-fs fontsize = set the default fontsize used for the text on the buttons" & @CRLF _
			 & "-a = log activated/focussed executables into WinButtons-active-exes.log" & @CRLF _
			 & "-ah or -ah- = althide mode enabled or disabled" & @CRLF _
			 & "[-f] buttonfile = read buttons and settings from file (default: WinButtons.ini)" & @CRLF _
			 & @CRLF & @TAB & "See WinButtons.readme.txt for all parameters and options" _
			)
EndFunc   ;==>ShowHelp

;---------------------------------
; WindowHide
; Hide a window by handle
Func WindowHide($handle)
	If $altHide Then
		WinSetState($handle, "", @SW_HIDE)
	Else
		Return _WinAPI_SetWindowPos($handle, $HWND_NOTOPMOST, 0, 0, 0, 0, BitOR($SWP_HIDEWINDOW, $SWP_NOACTIVATE, $SWP_NOMOVE, $SWP_NOZORDER, $SWP_NOSIZE))
	EndIf
EndFunc	;==>WindowHide

;---------------------------------
; WindowShow
; Show a window by handle
Func WindowShow($handle)
	If $altHide Then
		return WinSetState($handle, "", @SW_SHOW)
	Else
		Return _WinAPI_SetWindowPos($handle, $HWND_NOTOPMOST, 0, 0, 0, 0, BitOR($SWP_SHOWWINDOW, $SWP_NOACTIVATE, $SWP_NOMOVE, $SWP_NOZORDER, $SWP_NOSIZE))
	EndIf
EndFunc	;==>WindowShow

; Taken from WinAPI.au3 for size reasons, calling this is *much* faster than WinSetState
; #FUNCTION# ====================================================================================================================
; Name...........: _WinAPI_SetWindowPos
; Description ...: Changes the size, position, and Z order of a child, pop-up, or top-level  window
; Syntax.........: _WinAPI_SetWindowPos($hWnd, $hAfter, $iX, $iY, $iCX, $iCY, $iFlags)
; Parameters ....: $hWnd        - Handle of window
;                  $hAfter      - Identifies the window to precede the positioned window in the Z order. This parameter must be a
;                  +window handle or one of the following values:
;                  |$HWND_BOTTOM    - Places the window at the bottom of the Z order
;                  |$HWND_NOTOPMOST - Places the window above all non-topmost windows
;                  |$HWND_TOP       - Places the window at the top of the Z order
;                  |$HWND_TOPMOST   - Places the window above all non-topmost windows
;                  $iX          - Specifies the new position of the left side of the window
;                  $iY          - Specifies the new position of the top of the window
;                  $iCX         - Specifies the new width of the window, in pixels
;                  $iCY         - Specifies the new height of the window, in pixels
;                  $iFlags      - Specifies the window sizing and positioning flags:
;                  |$SWP_DRAWFRAME      - Draws a frame around the window
;                  |$SWP_FRAMECHANGED   - Sends a $WM_NCCALCSIZE message to the window, even if the window's size is not changed
;                  |$SWP_HIDEWINDOW     - Hides the window
;                  |$SWP_NOACTIVATE     - Does not activate the window
;                  |$SWP_NOCOPYBITS     - Discards the entire contents of the client area
;                  |$SWP_NOMOVE         - Retains the current position
;                  |$SWP_NOOWNERZORDER  - Does not change the owner window's position in the Z order
;                  |$SWP_NOREDRAW       - Does not redraw changes
;                  |$SWP_NOREPOSITION   - Same as the $SWP_NOOWNERZORDER flag
;                  |$SWP_NOSENDCHANGING - Prevents the window from receiving $WM_WINDOWPOSCHANGING
;                  |$SWP_NOSIZE         - Retains the current size
;                  |$SWP_NOZORDER       - Retains the current Z order
;                  |$SWP_SHOWWINDOW     - Displays the window
; Return values .: Success      - True
;                  Failure      - False
; Author ........: Paul Campbell (PaulIA)
; Modified.......:
; Remarks .......: Needs Constants.au3 for pre-defined constants
; Related .......:
; Link ..........: @@MsdnLink@@ SetWindowPos
; Example .......:
; ===============================================================================================================================
Func _WinAPI_SetWindowPos($hWnd, $hAfter, $iX, $iY, $iCX, $iCY, $iFlags)
	Local $aResult = DllCall("user32.dll", "bool", "SetWindowPos", "hwnd", $hWnd, "hwnd", $hAfter, "int", $iX, "int", $iY, "int", $iCX, _
			"int", $iCY, "uint", $iFlags)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0]
EndFunc   ;==>_WinAPI_SetWindowPos

; TODO: Retrieve the actually set MenuFont size
Func getSystemFontSize()
	;Const $SM_CYCAPTION = 4
	;Const $SM_CXFIXEDFRAME = 7

	;$retval = DllCall('user32.dll', 'int', 'GetSystemMetrics', 'int', $SM_CYCAPTION)
	;$retval = $retval[0]
	Return 9
EndFunc
